<?php

App::uses('EvShippingAppController', 'EvShipping.Controller');
App::uses('ArrayUtil', 'EvCore.Lib');

class ZonesController extends EvShippingAppController {

	/**
	 * redefine to add country to the drop down
	 *
	 * @return array
	 */
	protected function _adminIndexColumns() {
		$columns = parent::_adminIndexColumns();

		return ArrayUtil::addAfter(
			$columns,
			'Zone.name',
			array(
				'Country.name' => array(
					'type' => 'string',
					'label' => 'Country'
				)
			)
		);
	}

	/**
	 * redefine to pull countries
	 *
	 * @return array
	 */
	protected function _adminIndexPaginate() {
		$paginate = parent::_adminIndexPaginate();

		$paginate['contain'][] = 'Country';

		return $paginate;
	}

	/**
	 * redefine to populate country dropdown
	 */
	protected function _adminPopulateLookups() {
		parent::_adminPopulateLookups();

		$Country = EvClassRegistry::init('EvCountry.Country');

		$this->set(
			'countries',
			$Country->getForDropdown()
		);
	}

	/**
	 * redefine admin_edit to add the zone extras tab
	 */
	public function admin_edit($id = null) {
		$this->toInject['helpers']['ZoneExtras'] = 'EvShipping.ZoneExtras';

		parent::admin_edit($id);
	}
}
